-- ===================================================================

local reg_node = ocutil.safe_register_node
local img
local neednode

-- ===================================================================

reg_node ("extra:cobble_condensed", {
    description       = "Condensed Cobblestone" ,
    is_ground_content = false                   ,
    groups            = { cracky=1, stone=2 }   ,
    stack_max         = 999                     ,
    sounds            = default.sound_stone()   ,

    tiles = {
        "moreblocks_cobble_compressed.png^[colorize:black:255]"
    } ,
})

-- ===================================================================

img      = "extra_tequila.png"
neednode = "extra:tequila"
--
if  ocutil.thing_missing (neednode) then
    ocutil.safe_register_node (neednode, {
        description       = "Bottle of Tequila"     ,
        drawtype          = "plantlike"             ,
        is_ground_content = false                   ,
        paramtype         = "light"                 ,
        sounds            = default.sound_glass()   ,
        walkable          = false                   ,

        tiles             = { img }                 ,
        inventory_image   =   img                   ,
        wield_image       =   img                   ,

        selection_box = {
            type  = "fixed" ,
            fixed = { -0.25, -0.50, -0.25, 0.25, 0.30, 0.25 } ,
        } ,

        groups = {
            vessel=1, dig_immediate=3, attached_node=1
        } ,

        on_use = minetest.item_eat (10, "vessels:glass_bottle") ,
   })
end

-- ===================================================================

img      = "extra_rum.png"
neednode = "extra:rum"
--
if  ocutil.thing_missing (neednode) then
    ocutil.safe_register_node (neednode, {
        description       = "Bottle of Rum"         ,
        drawtype          = "plantlike"             ,
        is_ground_content = false                   ,
        paramtype         = "light"                 ,
        sounds            = default.sound_glass()   ,
        walkable          = false                   ,

        tiles             = { img }                 ,
        inventory_image   =   img                   ,
        wield_image       =   img                   ,

        selection_box = {
            type  = "fixed" ,
            fixed = { -0.25, -0.50, -0.25, 0.25, 0.30, 0.25 } ,
        } ,

        groups = {
            vessel=1, dig_immediate=3, attached_node=1
        } ,

        on_use = minetest.item_eat (10, "vessels:glass_bottle") ,
   })
end

-- ===================================================================
-- End of file.
