-- ===================================================================

local cvt      = default.convert_node
local reg_node = ocutil.safe_register_node
local neednode

-- ===================================================================

neednode = "flowers:seaweed_2"
--
if  minetest.registered_nodes [neednode] == nil then
    local function register_seaweed (num)
        reg_node ("flowers:seaweed_" .. num, {
            description     = "Seaweed"               ,
            drawtype        = "nodebox"               ,
            inventory_image = "flowers_seaweed_2.png" ,
            wield_image     = "flowers_seaweed_2.png" ,
            paramtype       = "light"                 ,
            paramtype2      = "facedir"               ,
            walkable        = false                   ,
            sounds          = default.sound_leaves()  ,

            groups        = {
                crumbly=1, oddly_breakable_by_hand=1
            } ,

            tiles         = {
                "flowers_seaweed_"..num..".png" ,
                "flowers_seaweed_"..num..".png^[transformFY"
            } ,

            selection_box = {
                type  = "fixed" ,
                fixed = { -0.40, -0.50, -0.40, 0.40, -0.45, 0.40 } ,
            } ,

            node_box      = {
                type  = "fixed" ,
                fixed = { -0.50, -0.49, -0.50, 0.50, -0.49, 0.50 } ,
            } ,

            buildable_to        = true       ,
            sunlight_propagates = true       ,
            liquids_pointable   = true       ,

            drop = "flowers:seaweed_" .. num ,
        })
    end

    register_seaweed (1)
    register_seaweed (2)
    register_seaweed (3)
    register_seaweed (4)
end

-- ===================================================================

cvt ("flowers:sunflower"        ,
     "nftools:sunflower"        )
cvt ("flowers:seaweed"          ,
     "flowers:seaweed_1"        )

-- ===================================================================

cvt ("flowers:waterlily_45"     ,
     "flowers:waterlily"        )
cvt ("flowers:waterlily_225"    ,
     "flowers:waterlily"        )
cvt ("flowers:waterlily_675"    ,
     "flowers:waterlily"        )
cvt ("flowers:waterlily_s1"     ,
     "flowers:waterlily"        )
cvt ("flowers:waterlily_s2"     ,
     "flowers:waterlily"        )
cvt ("flowers:waterlily_s3"     ,
     "flowers:waterlily"        )
cvt ("flowers:waterlily_s4"     ,
     "flowers:waterlily"        )

-- ===================================================================
-- End of file.
