-- Nodes

minetest.register_node (":ocean:sea_lantern", {
    description = "Sea Lantern" ,
    paramtype2 = "facedir",
    is_ground_content = false,
    stack_max = 64,
    light_source = minetest.LIGHT_MAX-1,
    drop = {
        max_items = 1,
        items = {
            { items = {'ocean:prismarine_crystals 3'}, rarity = 2 },
            { items = {'ocean:prismarine_crystals 2'}}
        }
    },
    tiles = {{name="ocean_sea_lantern.png", animation={type="vertical_frames", aspect_w=32, aspect_h=32, length=1.25}}},
    groups = {handy=1, building_block=1, material_glass=1},
    sounds = default.sound_glass(),
})

minetest.register_node (":ocean:prismarine", {
    description = "Prismarine" ,
    stack_max = 64,
    is_ground_content = false,
    -- Texture should have 22 frames for smooth transitions.
    tiles = {{name="ocean_prismarine_anim.png", animation={type="vertical_frames", aspect_w=32, aspect_h=32, length=45.0}}},
    groups = {pickaxey=1, building_block=1, material_stone=1},
    sounds = default.sound_stone(),
})

minetest.register_node (":ocean:prismarine_brick", {
    description = "Prismarine Bricks" ,
    stack_max = 64,
    is_ground_content = false,
    tiles = {"ocean_prismarine_bricks.png"},
    groups = {pickaxey=1, building_block=1, material_stone=1},
    sounds = default.sound_stone(),
})
minetest.register_alias ("ocean:prismarine_bricks" ,
                         "ocean:prismarine_brick"  )

minetest.register_node (":ocean:prismarine_dark", {
    description = "Dark Prismarine" ,
    stack_max = 64,
    is_ground_content = false,
    tiles = {"ocean_prismarine_dark.png"},
    groups = {pickaxey=1, building_block=1, material_stone=1},
    sounds = default.sound_stone(),
})

-- Craftitems

minetest.register_craftitem (":ocean:prismarine_crystals", {
    description = "Prismarine Crystals" ,
    inventory_image = "ocean_prismarine_crystals.png",
    stack_max = 64,
    groups = { craftitem = 1 },
})

minetest.register_craftitem (":ocean:prismarine_shard", {
    description = "Prismarine Shard" ,
    inventory_image = "ocean_prismarine_shard.png",
    stack_max = 64,
    groups = { craftitem = 1 },
})

-- Crafting

minetest.register_craft({
    output = 'ocean:sea_lantern',
    recipe = {
        {'ocean:prismarine_shard', 'ocean:prismarine_crystals', 'ocean:prismarine_shard'},
        {'ocean:prismarine_crystals', 'ocean:prismarine_crystals', 'ocean:prismarine_crystals'},
        {'ocean:prismarine_shard', 'ocean:prismarine_crystals', 'ocean:prismarine_shard'},
    }
})

minetest.register_craft({
    output = 'ocean:prismarine',
    recipe = {
        {'ocean:prismarine_shard', 'ocean:prismarine_shard'},
        {'ocean:prismarine_shard', 'ocean:prismarine_shard'},
    }
})

minetest.register_craft({
    output = 'ocean:prismarine_brick',
    recipe = {
        {'ocean:prismarine_shard', 'ocean:prismarine_shard', 'ocean:prismarine_shard'},
        {'ocean:prismarine_shard', 'ocean:prismarine_shard', 'ocean:prismarine_shard'},
        {'ocean:prismarine_shard', 'ocean:prismarine_shard', 'ocean:prismarine_shard'},
    }
})

minetest.register_craft({
    output = 'ocean:prismarine_dark',
    recipe = {
        {'ocean:prismarine_shard', 'ocean:prismarine_shard', 'ocean:prismarine_shard'},
        {'ocean:prismarine_shard', 'dye:black', 'ocean:prismarine_shard'},
        {'ocean:prismarine_shard', 'ocean:prismarine_shard', 'ocean:prismarine_shard'},
    }
})
