-- Super thanks to duane-r for his work:
-- https://github.com/duane-r/mobs_goblins/blob/work/goblin_traps.lua

reg_node = ocutil.safe_register_node

reg_node ("mobs:molten_gold_source", {
    description = "Molten Gold Source",
    inventory_image = minetest.inventorycube ("mobs_molten_gold.png") ,
    drawtype = "liquid" ,

    tiles = {
        {
            name = "molten_gold_source_animated.png",
            animation = {
                type = "vertical_frames",
                aspect_w = 16,
                aspect_h = 16,
                length = 3.0,
            } ,
        } ,
    } ,
    special_tiles = {
        -- New-style lava source material (mostly unused)
        {
            name = "molten_gold_source_animated.png",
            animation = {
                type     = "vertical_frames",
                aspect_w = 16,
                aspect_h = 16,
                length   = 3.0,
            } ,
            backface_culling = false,
        } ,
    } ,

    paramtype = "light",
    light_source = default.LIGHT_MAX - 1,
    walkable = false,
    pointable = false,
    diggable = false,
    buildable_to = true,
    is_ground_content = false,
    drop = "",
    drowning = 1,
    liquidtype = "source",
    liquid_alternative_flowing = "mobs:molten_gold_flowing" ,
    liquid_alternative_source  = "mobs:molten_gold_source"  ,
    liquid_viscosity = 7,
    liquid_renewable = false,
    liquid_range = 3,
    damage_per_second = 4 * 2,
    post_effect_color = {a=192, r=255, g=64, b=0} ,
    groups = {lava=3, liquid=2, hot=3, igniter=1} ,
})

reg_node ("mobs:molten_gold_flowing", {
    description = "Flowing Molten Gold",
    inventory_image = minetest.inventorycube("default_lava.png"),
    drawtype = "flowingliquid",
    tiles = {"default_lava.png"} ,
    special_tiles = {
        {
            name = "molten_gold_flowing_animated.png",
            backface_culling = false,
            animation = {
                type = "vertical_frames",
                aspect_w = 16,
                aspect_h = 16,
                length = 3.3,
            } ,
        } ,
        {
            name = "molten_gold_flowing_animated.png",
            backface_culling = true,
            animation = {
                type = "vertical_frames",
                aspect_w = 16,
                aspect_h = 16,
                length = 3.3,
            } ,
        } ,
    } ,

    paramtype = "light",
    paramtype2 = "flowingliquid",
    light_source = default.LIGHT_MAX - 1,
    walkable = false,
    pointable = false,
    diggable = false,
    buildable_to = true,
    is_ground_content = false,
    drop = "",
    drowning = 1,
    liquidtype = "flowing",
    liquid_alternative_flowing = "mobs:molten_gold_flowing",
    liquid_alternative_source = "mobs:molten_gold_source",
    liquid_viscosity = 7,
    liquid_renewable = false,
    liquid_range = 3,
    damage_per_second = 4 * 2,
    post_effect_color = {a=192, r=255, g=64, b=0} ,
    groups = {lava=3, liquid=2, hot=3, igniter=1, not_in_creative_inventory=1} ,
})

if 0 == 1 then
bucket.register_liquid (
    "mobs:molten_gold_source",
    "mobs:molten_gold_flowing",
    "mobs:bucket_molten_gold",
    "mobs_bucket_molten_gold.png",
    "Molten Gold Bucket",
    {lava_bucket = 1}
)
end
