-- ===================================================================

local reg_alias = ocutil.safe_register_alias
local reg_item  = ocutil.safe_register_item
local reg_node  = ocutil.safe_register_node

local needitem
local neednode

-- ===================================================================

reg_alias ("moreores:copper_ingot"  ,
           "default:copper_ingot"   )

reg_alias ("moreores:mineral_tin"   ,
           "default:tinblock"       )

reg_alias ("moreores:tin_block"     ,
           "default:tinblock"       )

reg_alias ("moreores:tin_ingot"     ,
           "default:tin_ingot"      )

-- ===================================================================

neednode = "moreores:mithril_block"
--
if ocutil.thing_missing (neednode) then
    reg_node (neednode, {
        description = "Mithril Block" ,
        tiles = { "moreores_mithril_block.png" } ,
        paramtype = "light",
        light_source = 2 ,
        groups = { cracky=2 } ,
        sounds = default.sound_stone() ,
    })
end

-- ===================================================================

nodepart = "mithril_block"
fromnode = "moreores:" .. nodepart
--
if ocutil.node_exists (fromnode) then
    stairs.register_all (nodepart, fromnode,
        { cracky=2                            } ,
        { "moreores_mithril_block.png"        } ,
        "Mithril Block"                         ,
        stairs.snd_stone)
end

-- ===================================================================

neednode = "moreores:sword_mithril"
--
if ocutil.node_missing (neednode) then
    minetest.register_tool (":" .. neednode, {
        description       = "Mithril Sword"                  ,
        inventory_image   = "moreores_tool_mithrilsword.png" ,

        tool_capabilities = {
            full_punch_interval = 0.25 ,
            max_drop_level      = 1    ,
            groupcaps           = {
                snappy   = {
                    times    = { [1]=0.70, [2]=0.80, [3]=0.25 } ,
                    uses     = 80 ,
                    maxlevel =  3 ,
                } ,
            } ,
            damage_groups = { fleshy=8 } ,
        }
    })
end

-- ===================================================================
-- End of file.
