-- ===================================================================

local cvt       = default.convert_node
local reg_alias = ocutil.safe_register_alias

-- ===================================================================

local intebase
local basenode
local neednode
local nodebase
local sta_node

-- ===================================================================

local seastone_brick_colors = { "aqua" ,"cyan" , "skyblue" }

for _, color in ipairs (seastone_brick_colors) do
    local uccolor = ocutil.first_to_upper (color)

    nodebase = "seastonebrick_" .. color
    neednode = "stairs:slab_"   .. nodebase
    --
    intebase = "seabrick_"    .. color
    basenode = "codersea:"    .. intebase
    sta_node = "stairs:slab_" .. intebase
    --
    if  ocutil.thing_missing (neednode) and
        ocutil.node_exists   (basenode) and
        stairs.register_slab ~= nil     then

        stairs.register_slab (nodebase, basenode   ,
            {  cracky=3, stone=1                }  ,
            { "codersea_" .. intebase .. ".png" }  ,
            uccolor .. "Sea-Brick")

        cvt (neednode, sta_node)

        stairs.register_stair (nodebase, basenode  ,
            {  cracky=3, stone=1                }  ,
            { "codersea_" .. intebase .. ".png" }  ,
            uccolor .. "Sea-Brick")

        neednode = neednode:gsub (":slab_", ":stair_")
        sta_node = sta_node:gsub (":slab_", ":stair_")
        cvt (neednode, sta_node)
    end
end

-- ===================================================================

if false then -- Future
nodebase = "seastonebrick_cyan"
neednode = "stairs:stair_" .. nodebase
--
intebase = "seabrick_cyan"
basenode = "codersea:"    .. intebase
sta_node = "stairs:stair_" .. intebase
--
if  ocutil.thing_missing (neednode) and
    ocutil.node_exists   (basenode) and
    stairs.register_stair ~= nil     then
    stairs.register_stair (nodebase, basenode  ,
        {  cracky=3, stone=1                } ,
        { "codersea_" .. intebase .. ".png" } ,
        "Cyan Sea-Brick")
end

cvt (neednode, sta_node)
end

-- ===================================================================

neednode = "stairs:slab_stonewall"
fromnode = "castle_masonry:stonewall"
--
if  minetest.registered_nodes [neednode] == nil and
    minetest.registered_nodes [fromnode] ~= nil and
    stairs.register_slab ~= nil then
    stairs.register_slab ("stonewall",
        fromnode ,
        { cracky=3 } ,
        { "castle_stonewall.png" } ,
        "Castle Wall")
end

cvt ("castle:slab_stonewall", neednode)

-- ===================================================================

neednode = "stairs:stair_stonewall"
fromnode = "castle_masonry:stonewall"
--
if  minetest.registered_nodes [neednode] == nil and
    minetest.registered_nodes [fromnode] ~= nil and
    stairs.register_stair ~= nil then
    stairs.register_stair ("stonewall",
        fromnode ,
        { cracky=3 } ,
        { "castle_stonewall.png" } ,
        "Castle Wall")
end

-- ===================================================================

nodebase = "seastonebrick_cyan"
basenode = "codersea:"          .. nodebase
sta_node = "stairs:stair_"      .. nodebase
neednode = sta_node
--
if  ocutil.thing_missing (neednode) and
    ocutil.node_exists   (basenode) and
    stairs.register_stair ~= nil    then
    stairs.register_stair (nodebase, basenode ,
        {  snappy=2, cracky=3 } ,
        { "codersea_" .. nodebase .. ".png" } ,
        "Cyan Seastone Brick")
end

-- ===================================================================

nodebase = "beech_planks"
basenode = "default:"         .. nodebase
sta_node = "stairs:stair_"    .. nodebase
neednode = "moretrees:stair_" .. nodebase
--
if  ocutil.thing_missing (neednode) and
    ocutil.node_exists   (basenode) and
    stairs.register_stair ~= nil    then
    stairs.register_stair (nodebase, basenode ,
        {
            snappy=1, choppy=2, oddly_breakable_by_hand=2 ,
            flammable=3, wood=1
        } ,
        { "default_beech_wood.png" } ,
        "Beech")
end

cvt (neednode, sta_node)

-- ===================================================================

cvt ("stairs:slab_castle_pavement_brick"           ,
            "stairs:slab_pavement_brick"           )

cvt (  "moretrees:slope_beech_planks"              ,
          "stairs:slope_beech_wood"                )

cvt (        "moretrees:rubber_tree_planks"        ,
               "default:rubber_wood"               )

cvt (   "moretrees:slab_rubber_tree_planks"        ,
       "moreblocks:slab_rubber_wood"               )

cvt (  "moretrees:stair_rubber_tree_planks_alt"    ,
      "moreblocks:stair_rubber_wood"               )

cvt  ( "moreblocks:slab_pinewood_1"                ,
           "stairs:slab_pine_wood"                 )

cvt  ("moreblocks:stair_pinewood"                  ,
          "stairs:stair_pine_wood"                 )

-- ===================================================================
-- End of module.
