-- ===================================================================

local bedcolors = {
    "red"      ,
    "green"    ,
    "blue"     ,
    "darkgrey" ,
}

-- ===================================================================

for _, ocolor in ipairs (bedcolors) do
    local color = ocolor
 
    minetest.register_node (":homedecor:bed_" .. color .. "_head", {
        tiles = {
            "homedecor_bed_"..color.."_top1.png",
            "homedecor_bed_bottom1.png",
            "homedecor_bed_"..color.."_side1.png",
            "homedecor_bed_"..color.."_side1.png^[transformFX",
            "homedecor_bed_head1.png",
            "homedecor_bed_"..color.."_head2.png"
        } ,

        drawtype = "nodebox",
        paramtype = "light",
        paramtype2 = "facedir",
        groups = {snappy=3, not_in_creative_inventory=1} ,

        node_box = {
            type = "fixed",
            fixed = {
                {-0.5,     -0.5,     0.4375,   -0.375,  0.5,      0.5} ,      --  NodeBox1
                {0.375,    -0.5,     0.4375,   0.5,     0.5,      0.5} ,      --  NodeBox2
                {-0.5,     0.25,     0.4375,   0.5,     0.4375,   0.5} ,      --  NodeBox3
                {-0.5,     -0.0625,        0.4375,   0.5,     0.1875,   0.5} ,      --  NodeBox4
                {-0.5,  -0.375,   -0.5,     0.5,  -0.125,   0.5} ,      --  NodeBox5
                {0.375,    -0.375,   -0.5,     0.4375,  -0.125,   0.5} ,      --  NodeBox6
                {-0.4375,   -0.3125,  -0.5,     0.4375,   -0.0625,  0.4375} ,   --  NodeBox7
                {-0.3125,  -0.125,   0.0625,   0.3125,  0.0625,   0.4375} ,   --  NodeBox8
            }
        } ,

        selection_box = {
            type = "fixed",
            fixed = { 0, 0, 0, 0, 0, 0 }
        }
    })

    minetest.register_node (":homedecor:bed_" .. color .. "_foot", {
        tiles = {
            "homedecor_bed_"..color.."_top2.png",
            "homedecor_bed_bottom2.png",
            "homedecor_bed_"..color.."_side2.png",
            "homedecor_bed_"..color.."_side2.png^[transformFX",
            "homedecor_bed_foot2.png",
            "homedecor_bed_"..color.."_foot1.png"
        } ,

        inventory_image = "homedecor_bed_"..color.."_inv.png",
        description = color .. " bed" ,
        drawtype = "nodebox",
        paramtype = "light",
        paramtype2 = "facedir",
        groups = {snappy=3} ,

        node_box = {
            type = "fixed",
            fixed = {
                {-0.5,     -0.5,     -0.5,     -0.375,  0.1875,   -0.4375} ,  --  NodeBox1
                {0.375,    -0.5,     -0.5,     0.5,     0.1875,   -0.4375} ,  --  NodeBox2
                {-0.5,     0,        -0.5,     0.5,     0.125,    -0.4375} ,  --  NodeBox3
                {-0.5,     -0.375,   -0.5,     0.5,     -0.125,   -0.4375} ,  --  NodeBox4
                {-0.5,  -0.375,   -0.5,     0.5,  -0.125,   0.5} ,      --  NodeBox5
                {0.375,    -0.375,   -0.5,     0.4375,  -0.125,   0.5} ,      --  NodeBox6
                {-0.4375,   -0.3125,  -0.4375,  0.4375,   -0.0625,  0.5} ,      --  NodeBox7
            }
        } ,

        selection_box = {
            type = "fixed",
            fixed = { -0.5, -0.5, -0.5, 0.5, 0.5, 1.5 }
        } ,
    })
end

-- ===================================================================

minetest.register_alias ("homedecor:bed_brown_foot"    ,
                         "homedecor:bed_darkgrey_foot" )
minetest.register_alias ("homedecor:bed_brown_head"    ,
                         "homedecor:bed_darkgrey_head" )

minetest.register_alias ("homedecor:bed_pink_foot"     ,
                         "homedecor:bed_red_foot"      )
minetest.register_alias ("homedecor:bed_pink_head"     ,
                         "homedecor:bed_red_head"      )

minetest.register_alias ("homedecor:bed_violet_head"   ,
                         "homedecor:bed_blue_head"     )
minetest.register_alias ("homedecor:bed_violet_foot"   ,
                         "homedecor:bed_blue_foot"     )

minetest.register_alias ("homedecor:bed_yellow_head"   ,
                         "homedecor:bed_green_head"    )
minetest.register_alias ("homedecor:bed_yellow_foot"   ,
                         "homedecor:bed_green_foot"    )

minetest.register_alias ("homedecor:bed_orange_head"   ,
                         "homedecor:bed_green_head"    )
minetest.register_alias ("homedecor:bed_orange_foot"   ,
                         "homedecor:bed_green_foot"    )

-- ===================================================================
-- End of file.
