-- File:     codersea/legacy.lua
-- Purpose:  CoderSea aliases for obsolete objects
-- Credits:  See "codersea.md"
-- Licenses: See "LICENSE"

local cvt       = default.convert_node
local reg_alias = ocutil.safe_register_alias

minetest.register_node ("codersea:lantern", {
    description = "Sea lantern",
    drawtype = "torchlike",

    tiles = {
        { name="sealamps_lantern_on_floor.png"   } ,
        { name="sealamps_lantern_on_ceiling.png" } ,
        { name="sealamps_lantern.png"            } ,
    } ,

    inventory_image = "sealamps_lantern_on_floor.png" ,
    wield_image     = "sealamps_lantern_on_floor.png" ,
    paramtype       = "light"                         ,
    paramtype2 = "wallmounted",
    sunlight_propagates = true,
    walkable = false,
    light_source = default.LIGHT_MAX-1,

    selection_box = {
        type = "wallmounted",
        wall_top    = { -0.1, 0.5-0.6, -0.1, 0.1, 0.5, 0.1 } ,
        wall_bottom = { -0.1, -0.5, -0.1, 0.1, -0.5+0.6, 0.1 } ,
        wall_side   = { -0.5, -0.3, -0.1, -0.5+0.3, 0.3, 0.1 } ,
    } ,

    groups = {
        choppy=2, dig_immediate=3, attached_node=1, hot=2, sea=1
    } ,
    legacy_wallmounted = true ,
    sounds = default.node_sound_defaults() ,
})

-- ===================================================================

cvt ("seacobble:seacobble_aqua"                 ,
      "codersea:seacobble_aqua"                 )

cvt ("seacobble:seacobble"                      ,
      "codersea:seacobble"                      )

cvt ("seacobble:seacobble_cyan"                 ,
      "codersea:seacobble_cyan"                 )

cvt ("seacobble:seacobble_lime"                 ,
      "codersea:seacobble_lime"                 )

cvt ("seacobble:seacobble_magenta"              ,
      "codersea:seacobble_magenta"              )

cvt ("seacobble:seacobble_redviolet"            ,
      "codersea:seacobble_redviolet"            )

cvt ("seacobble:seacobble_skyblue"              ,
      "codersea:seacobble_skyblue"              )

cvt ("seaglass:yellowlightglass"                ,
     "codersea:seaglass_yellow_off"             )

cvt ("seaglass:redlightglass"                   ,
     "codersea:seaglass_red_off"                )

cvt ("seaglass:bluelightglass"                  ,
     "codersea:seaglass_blue_off"               )

cvt ("seaglass:whitelightglass"                 ,
     "codersea:seaglass_white_off"              )

cvt ("seaglass:blacklightglass"                 ,
     "codersea:seaglass_black_off"              )

cvt ("seagravel:seagravel_aqua"                 ,
      "codersea:seagravel_aqua"                 )

cvt ("seagravel:seagravel"                      ,
      "codersea:seagravel"                      )

cvt ("seagravel:seagravel_cyan"                 ,
      "codersea:seagravel_cyan"                 )

cvt ("seagravel:seagravel_lime"                 ,
      "codersea:seagravel_lime"                 )

cvt ("seagravel:seagravel_magenta"              ,
      "codersea:seagravel_magenta"              )

cvt ("seagravel:seagravel_redviolet"            ,
      "codersea:seagravel_redviolet"            )

cvt ("seagravel:seagravel_skyblue"              ,
      "codersea:seagravel_skyblue"              )

cvt ("sealamps:lantern"                         ,
     "codersea:lantern"                         )

cvt ("seastone:seastone_aqua"                   ,
     "codersea:seastone_aqua"                   )

cvt ("seastone:seastone"                        ,
     "codersea:seastone"                        )

cvt ("seastone:seastone_cyan"                   ,
     "codersea:seastone_cyan"                   )

cvt ("seastone:seastone_lime"                   ,
     "codersea:seastone_lime"                   )

cvt ("seastone:seastone_magenta"                ,
     "codersea:seastone_magenta"                )

cvt ("seastone:seastone_redviolet"              ,
     "codersea:seastone_redviolet"              )

cvt ("seastone:seastone_skyblue"                ,
     "codersea:seastone_skyblue"                )

cvt ("seastonebrick:seastonebrick_aqua"         ,
               "codersea:seabrick_aqua"         )

cvt ("seastonebrick:seastonebrick"              ,
               "codersea:seabrick"              )

cvt ("seastonebrick:seastonebrick_cyan"         ,
               "codersea:seabrick_cyan"         )

cvt ("seastonebrick:seastonebrick_lime"         ,
               "codersea:seabrick_lime"         )

cvt ("seastonebrick:seastonebrick_magenta"      ,
               "codersea:seabrick_magenta"      )

cvt ("seastonebrick:seastonebrick_redviolet"    ,
               "codersea:seabrick_redviolet"    )

cvt ("seastonebrick:seastonebrick_skyblue"      ,
               "codersea:seabrick_skyblue"      )

-- ===================================================================

cvt ("codersea:seastonebrick_aqua"          ,
          "codersea:seabrick_aqua"          )

cvt ("codersea:seastonebrick"               ,
          "codersea:seabrick"               )

cvt ("codersea:seastonebrick_cyan"          ,
          "codersea:seabrick_cyan"          )

cvt ("codersea:seastonebrick_lime"          ,
          "codersea:seabrick_lime"          )

cvt ("codersea:seastonebrick_magenta"       ,
          "codersea:seabrick_magenta"       )

cvt ("codersea:seastonebrick_redviolet"     ,
          "codersea:seabrick_redviolet"     )

cvt ("codersea:seastonebrick_skyblue"       ,
          "codersea:seabrick_skyblue"       )

cvt ("seawrecks:woodship"                   ,
      "codersea:woodship"                   )

cvt ("seawrecks:uboot"                      ,
      "codersea:uboot"                      )

cvt ("seawrecks:woodshipchest"              ,
      "codersea:woodshipchest"              )

cvt ("seawrecks:ubootchest"                 ,
      "codersea:ubootchest"                 )

-- ===================================================================

cvt ("stairs:slab_seastonebrick"            ,
          "stairs:slab_seabrick"            )
cvt ("stairs:stair_seastonebrick"           ,
          "stairs:stair_seabrick"           )

-- ===================================================================
-- End of file.
