-- File:     codersea/seabrick.lua
-- Purpose:  CoderSea sea-brick support
-- Credits:  See "codersea.md"
-- Licenses: See "LICENSE"

-- ===================================================================

local function register_seabrick_craft (output, recipe)
    minetest.register_craft ({
       output = output ,
       recipe = recipe ,
    })
end

-- ===================================================================

local function register_seabrick    (suffix)
    local basename =   "seabrick" .. suffix
    local esuffix  = suffix:gsub ("_", " ")
    local nodename = "codersea:" .. basename
    local img      = "codersea_" .. basename .. ".png"
    local stone    = "codersea:seastone" .. suffix

    minetest.register_node (nodename, {
        description       = "Sea brick" .. esuffix  ,
        groups            = { cracky=2, stone=1 }   ,
        is_ground_content = true                    ,
        sounds            = sounds_stone            ,
        tiles             = { img }                 ,
    })

    if not codersea_disable_stairs then
        stairs.register_stair_and_slab (basename, nodename,
            { cracky=3, stone=1 }              ,
            { img }                            ,
            "Sea-brick" .. esuffix .. " stair" ,
            "Sea-brick" .. esuffix .. " slab"  ,
            sounds_stone)
    end

    register_seabrick_craft (nodename,
    {
        { stone , stone } ,
        { stone , stone } ,
    })
end

-- ===================================================================

for  _,color in pairs (seastone_colors) do
    if color:len() > 0 then color = "_" .. color end
    register_seabrick (color)
end
