-- ===================================================================
-- "ufoods" common header.

local S
if minetest.get_modpath ("intllib") then
    S = intllib.Getter()
else
    S = function (s) return s end
end

local item_eat     = unified_foods.item_eat
local keep_vessels = unified_foods.keep_vessels
local mra          = minetest.registered_aliases
local mri          = minetest.registered_items

local reg_alias    = ocutil.safe_register_alias
local reg_craft    = minetest.register_craft
local reg_food     = unified_foods.register_food
local reg_item     = ocutil.safe_register_item
local reg_juice    = unified_foods.register_juice

local needitem

-- ===================================================================

local basename
local dgroups
local obj, obj1, obj2

-- ===================================================================

unified_foods.reg_dseries = function (basename, args)

    if     type (args) == "string" then
        args = { description = args }
    elseif type (args) ~= "table"  then
        ocutil.panic ("reg_dseries: Invalid arguments")
    end

    args.satiate = 1
    args.heal    = 1

    return unified_foods.register_food (basename, args)
end

local reg_dseries = unified_foods.reg_dseries

-- ===================================================================

reg_dseries ("snackcake" , "Snackcake"        )

-- ===================================================================

reg_dseries ("muffin"    , "Blueberry Muffin" )

-- ===================================================================

needitem = reg_dseries ("tart_base_raw", "Raw Tart Base")

reg_craft ({
    output       = needitem     ,
    replacements = keep_vessels ,

    recipe       = {
        { "group:food_flour", "group:food_milk", "group:food_egg" } ,
    } ,
})

-- ===================================================================

needitem = reg_dseries ("tart_base", "Tart Base")

reg_craft ({
    type   = "cooking"                  ,
    output = needitem                   ,
    recipe = "group:food_tart_base_raw" ,
})

-- ===================================================================

needitem = reg_dseries ("strawberry_tart" , "Strawberry Tart")

reg_craft ({
    output = needitem ,
    recipe = {
        { "group:food_strawberry" } ,
        { "group:food_tart_base"  } ,
    }
})

-- ===================================================================
-- End of file.
