-- ===================================================================
-- "ufoods" common header.

local S
if minetest.get_modpath ("intllib") then
    S = intllib.Getter()
else
    S = function (s) return s end
end

local item_eat     = unified_foods.item_eat
local keep_vessels = unified_foods.keep_vessels
local mra          = minetest.registered_aliases
local mri          = minetest.registered_items

local reg_alias    = ocutil.safe_register_alias
local reg_craft    = minetest.register_craft
local reg_food     = unified_foods.register_food
local reg_item     = ocutil.safe_register_item
local reg_juice    = unified_foods.register_juice

local needitem

-- ===================================================================

local basename
local dgroups
local obj, obj1, obj2

-- ===================================================================

needitem = reg_food ("banana_split",
    {
        description = "Banana Split" ,
        satiate     = 3              ,
    })

reg_craft ({
    output       = needitem     ,
    replacements = keep_vessels ,

    recipe       = {
        { "group:food_choco_milk" } ,
        { "group:food_cherries"   } ,
        { "group:food_banana"     } ,
    } ,
})

-- ===================================================================

needitem = reg_food ("shortbread" ,
    {
        description = "Shortbread" ,
        satiate     = 2            ,
    })

reg_craft ({
    output       = needitem     ,
    replacements = keep_vessels ,

    recipe       = {
        { "group:food_milk"  } ,
        { "group:food_bread" } ,
        { "group:food_sugar" } ,
    } ,
})

-- ===================================================================

needitem = reg_food ("cream",
    {
        description    = "Cream"         ,
        satiate        = 1               ,
        replace        = "food:glass"    ,
        external_items = "mtfoods:cream" ,
    })

reg_craft ({
    output       = needitem     ,
    replacements = keep_vessels ,

    recipe       = {
        { "group:food_milk"  } ,
        { "group:food_sugar" } ,
    } ,
})

-- ===================================================================

needitem = reg_food ("shortcake",
    {
        description    = "Strawberry Shortcake"         ,
        satiate        = 3                              ,
        external_items = "mtfoods:strawberry_shortcake" ,
    })

obj1 = "group:food_cream"
obj2 = "group:food_strawberry"

reg_craft ({
    output = needitem ,
    recipe = {
        { obj1, obj2                    , obj1 } ,
        { obj2, "group:food_shortbread" , obj2 } ,
    }
})

reg_alias ("food:strawberry_shortcake"    , needitem)
reg_alias ("mtfoods:strawberry_shortcake" , needitem)

-- ===================================================================

needitem = reg_food ("cupcake",
    {
        description = "Cupcake" ,
        satiate     = 3         ,
    })

reg_craft ({
    output       = needitem     ,
    replacements = keep_vessels ,

    recipe       = {
        { "group:food_cream"      } ,
        { "group:food_shortbread" } ,
        { "default:paper"         } ,
    }
})

-- ===================================================================

local food_cake_box = {
    type = "fixed",
    fixed = {
        {-0.250000,-0.500000,-0.296880,0.250000,-0.250000,0.312502},
        {-0.309375,-0.500000,-0.250000,0.309375,-0.250000,0.250000},
        {-0.250000,-0.250000,-0.250000,0.250000,-0.200000,0.250000}
    }
}

-- ===================================================================

minetest.register_node (":food:cake", {

    description = S("Generic Cake")     ,
    drawtype    = "nodebox"             ,
    groups      = { food=3, crumbly=3 } ,
    node_box    = food_cake_box         ,
    on_use      = item_eat (4)          ,
    paramtype   = "light"               ,
    walkable    = false                 ,

    tiles = {
        "food_cake_generic_top.png"  ,
        "food_cake_generic_top.png"  ,
        "food_cake_generic_side.png" ,
        "food_cake_generic_side.png" ,
        "food_cake_generic_side.png" ,
        "food_cake_generic_side.png" ,
    } ,

    sunlight_propagates = true ,
})

-- ===================================================================

minetest.register_node (":food:cake_choco", {

    description = S("Chocolate Cake")   ,
    drawtype    = "nodebox"             ,
    groups      = { food=3, crumbly=3 } ,
    node_box    = food_cake_box         ,
    on_use      = item_eat (4)          ,
    paramtype   = "light"               ,
    walkable    = false                 ,

    tiles = {
        "food_cake_choco_top.png"  ,
        "food_cake_choco_top.png"  ,
        "food_cake_choco_side.png" ,
        "food_cake_choco_side.png" ,
        "food_cake_choco_side.png" ,
        "food_cake_choco_side.png" ,
    } ,

    sunlight_propagates = true ,
})

-- ===================================================================

minetest.register_node (":food:cake_carrot", {

    description = S("Carrot Cake")      ,
    drawtype    = "nodebox"             ,
    groups      = { food=3, crumbly=3 } ,
    node_box    = food_cake_box         ,
    on_use      = item_eat (4)          ,
    paramtype   = "light"               ,
    walkable    = false                 ,

    tiles = {
        "food_cake_carrot_top.png"  ,
        "food_cake_carrot_top.png"  ,
        "food_cake_carrot_side.png" ,
        "food_cake_carrot_side.png" ,
        "food_cake_carrot_side.png" ,
        "food_cake_carrot_side.png" ,
    },

    sunlight_propagates = true ,
})

-- ===================================================================
-- End of file.
