-- Nyanland Angel.

-- ===================================================================

local lcname     = "angel"
local ucname     = "Angel"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance =   2000       ,

    day_mode     = true         ,
    min_light    =      0       ,
    max_light    =     25       ,
    min_height   =      0       ,
    max_height   =  31200       ,
    spawn_type   = "npc"        ,

    spawn_nodes  = {
        "nyanland:cloudstone"   ,
    } ,

--  spawn_by     = {
--      "nyanland:mesetree"     ,
--  } ,

    add_egg   = true                    ,
    egg_image = "angel_ornament.png"    ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {

    passive          = false       ,
    reach            =   1         ,
    damage           =   3         ,
    attack_type      = "dogfight"  ,
    attacks_monsters = true        ,
    hp_min           = 10          ,
    hp_max           = 20          ,
    armor            = 100         ,

    walk_velocity = 2           ,
    run_velocity  = 3           ,
    stepheight    = 1.2         ,
    jump_height   =   0         ,
    jump          = false       ,
    fall_speed    = -8          ,
    fear_height   =  4          ,
    view_range    = 15          ,
    owner         = ""          ,
    order         = "follow"    ,

    water_damage  =  0          ,
    lava_damage   =  2          ,
    light_damage  =  0          ,
    fall_damage   =  1          ,

    type                 = mobs_param.spawn_type           ,
    makes_footstep_sound = true                            ,

    blood_texture   = "mobs_blood.png"                     ,
    collisionbox    = { -0.3, -1.0, -0.3, 0.3, 0.8, 0.3 }  ,
    visual          = "mesh"                               ,
    drawtype        = "front"                              ,
    mesh            = "codermobs_humanoid.x"               ,
    textures        = {{ msname .. ".png" }}               ,
    visual          = "mesh"                               ,
    visual_size     = { x=1, y=1 }                         ,

    drops = {
        {
            name   = "default:coal_lump"   ,
            chance = 1 , min = 1 , max = 3 ,
        } ,
    } ,

    sounds = {
    } ,

    follow = {
        "food:cake_carrot" ,
        "food:cake_choco"  ,
    },

    animation = {
        stand_start  =   0 ,
        stand_end    =  79 ,
        walk_start   = 168 ,
        walk_end     = 187 ,
        run_start    = 168 ,
        run_end      = 187 ,
        punch_start  = 200 ,
        punch_end    = 219 ,
        speed_normal =  30 ,
        speed_run    =  30 ,
    } ,

    on_rightclick = function (self, clicker)

        -- feed to heal npc
        if not mobs:feed_tame (self, clicker, 8, true) then
            local item = clicker:get_wielded_item()
            local name = clicker:get_player_name()

            if 0 < 1 then
                -- if owner switch between follow and stand
                if self.owner and
                   self.owner == clicker:get_player_name() then
                    if self.order == "follow" then
                        self.order = "stand"
                    else
                        self.order = "follow"
                    end
                end
            end
        end

        mobs:capture_mob (self, clicker, 0, 5, 80, false, nil)
    end ,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
