-- Bat.

-- ===================================================================

local lcname     = "bat"
local ucname     = "Bat"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance = 250000       ,

    day_mode     = true         ,
    min_light    =      5       ,
    max_light    =     10       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_dry_grass"   ,
        "default:dirt_with_grass"       ,
        "earthgen:dirt_with_dry_grass"  ,
        "ethereal:green_dirt"           ,
        "ethereal:green_dirt_top"       ,
        "ethereal:grove_dirt"           ,
        "mg:dirt_with_dry_grass"        ,
        "noisegrid:grass"               ,
    } ,

    add_egg   = false                   ,
    egg_image = msname .. "_inv.png"    ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type         = mobs_param.spawn_type    ,
    damage = 1,
    reach         =   1         ,
    attack_type = "dogfight",
    hp_min = 7,
    hp_max = 12,
    armor = 130,
    collisionbox = {-0.4,-0.4,-0.4, 0.4,0.4,0.4},
    visual = "mesh",
    mesh = msname .. ".b3d",

    textures = {
        { msname .. ".png"},
        { msname .. ".png^[colorize:black:150" } ,
    } ,

    specific_attack = codermobs.make_mob_list ({
        "bird", "owl",
    }) ,


    rotate = 270,
    walk_velocity = 10,
    run_velocity = 23,
    fall_speed = 0,
    stepheight = 3,

    sounds = {
        random = msname ,
        war_cry = msname ,
        damage = msname ,
        attack =  msname ,
    } ,

    fly = true,
    water_damage = 2,
    lava_damage = 10,
    light_damage = 0,
    view_range = 10,

    animation = {
        speed_normal = 24,      speed_run = 24,
        stand_start = 30,       stand_end = 59,
        walk_start = 30,        walk_end = 59,
        run_start = 30,         run_end = 59,
        punch_start = 60,       punch_end = 89
    } ,

    on_rightclick = function(self, clicker)
        mobs:capture_mob(self, clicker, 5, 60, 0, true, nil)
    end ,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
