-- Bug. Descended from KrupnoPavel version.

-- ===================================================================

local lcname     = "bug"
local ucname     = "Bug"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =      3       ,
    spawn_chance =   2000       ,

    day_mode     = true         ,
    min_light    =      3       ,
    max_light    =     30       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "darkage:silt"                  ,
        "default:desert_sand"           ,
        "default:dirt_with_dry_grass"   ,
        "default:dirt_with_grass"       ,
        "default:sand"                  ,
        "default:silver_sand"           ,
        "default:stone"                 ,
        "earthgen:dirt_with_dry_grass"  ,
        "ethereal:dry_dirt"             ,
        "ethereal:green_dirt"           ,
        "ethereal:green_dirt_top"       ,
        "ethereal:mushroom_dirt"        ,
        "fargen:dirt_with_leafy_grass"  ,
        "loud_walking:polluted_dirt"    ,
        "mg:dirt_with_dry_grass"        ,
        "noisegrid:grass"               ,
    } ,

    add_egg   = false                   ,
    egg_image = msname .. "_inv.png"    ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    makes_footstep_sound = false ,

    -- Behavior/sight/battle
    armor         = 200          ,
    hp_max        =   1          ,
    hp_min        =   1          ,
    runaway       = true         ,

    -- Velocities
    walk_velocity =   1          ,

    -- Step/jump/fall parameters
    fall_damage   =   0          ,
    jump          = false        ,
    jump_height   =   0          ,
    stepheight    =   1.2        ,

    -- Environment damage
    lava_damage   =   1          ,
    light_damage  =   0          ,
    water_damage  =   2          ,

    -- Misc. parameters
    floats        =   0          ,

    collisionbox  = { -0.2, -0.01, -0.2, 0.2, 0.2, 0.2 } ,
    mesh          = msname .. ".x"                       ,
    visual        = "mesh"                               ,

    textures = {
        { msname .. "_01.png" },
        { msname .. "_02.png" },
        { msname .. "_03.png" },
        { msname .. "_04.png" },
        { msname .. "_05.png" },
        { msname .. "_06.png" },
        { msname .. "_07.png" },
        { msname .. "_08.png" },
    },

    drops    = {} ,
    drawtype = "front" ,

    on_rightclick = function (self, clicker)
        if clicker:is_player() and clicker:get_inventory() then
            mobs:force_capture (self, clicker)
        end
    end ,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
