-- Bunny. Descended from ExeterDad version.

-- ===================================================================

local lcname     = "bunny"
local ucname     = "Bunny"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance =  20000       ,

    day_mode     = true         ,
    min_light    =      1       ,
    max_light    =     20       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_dry_grass"   ,
        "default:dirt_with_grass"       ,
        "earthgen:dirt_with_dry_grass"  ,
        "ethereal:green_dirt"           ,
        "ethereal:prairie_dirt"         ,
        "fargen:dirt_with_leafy_grass"  ,
        "mg:dirt_with_dry_grass"        ,
        "noisegrid:grass"               ,
    } ,

    add_egg   = false                   ,
    egg_image = msname .. "_inv.png"    ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    passive = true,
    hp_min = 1,
    hp_max = 4,
    armor = 200,

--  Too small:
--  collisionbox = {-0.268, -0.50, -0.268,  0.268, 0.167, 0.268},
--  visual_size = {x=1, y=1},

    collisionbox = {-0.335, -0.62, -0.335,  0.335, 0.209, 0.335},
    visual_size = { x =1.25, y=1.25 },

--  Too large:
--  collisionbox = {-0.402, -0.75, -0.402,  0.402, 0.251, 0.402},
--  visual_size = {x=1.5, y=1.5},

    visual = "mesh",
    mesh = msname .. ".b3d",
    drawtype = "front",
    textures = {
        { msname .. "_grey.png"  } ,
        { msname .. "_brown.png" } ,
        { msname .. "_white.png" } ,
    },
    sounds = {},
    makes_footstep_sound = false,
    walk_velocity = 1,
    run_velocity = 2,
    stepheight    = 2.2         ,
    jump_height   =   0         ,
    jump          = false       ,

    drops = {
        { name="mobs:meat_raw", chance=1, min=1, max=2 } ,
    },

    water_damage = 1,
    floats = 0,
    runaway = true,
    lava_damage = 4,
    light_damage = 0,
    animation = {
        speed_normal = 15,
        stand_start = 1,
        stand_end = 15,
        walk_start = 16,
        walk_end = 24,
        punch_start = 16,
        punch_end = 24,
    },
    follow = {"farming:carrot", "farming_plus:carrot_item"},
    view_range = 10,
    replace_rate = 80,
    replace_what = {"farming:carrot_7", "farming:carrot_8", "farming_plus:carrot"},
    replace_with = "air",
    on_rightclick = function(self, clicker)
        if not mobs:feed_tame(self, clicker, 4, true) then
            -- Monty Python tribute
            local item = clicker:get_wielded_item()
            if item:get_name() == "mobs:lava_orb" then
                if not minetest.setting_getbool("creative_mode") then
                    item:take_item()
                    clicker:set_wielded_item(item)
                end
                self.object:set_properties({
                    textures = { "codermobs_bunny_evil.png" } ,
                })
                self.type = "monster"
                self.state = "attack"
                self.object:set_hp(20)
                return
            end
        end

        mobs:capture_mob(self, clicker, 30, 50, 80, false, nil)
    end,
    attack_type = "dogfight",
    damage = 5,
}

-- ===================================================================

codermobs.setup_mob()
mobs:alias_mob ("mobs:bunny"        , obj_name)
mobs:alias_mob ("mobs_animal:bunny" , obj_name)
codermobs.log_done()

-- ===================================================================
-- End of file.
