-- Elephant. Descended from Farlands version.

-- ===================================================================

local lcname     = "elephant"
local ucname     = "Elephant"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance = 120000       ,

    day_mode     = true         ,
    min_light    =     10       ,
    max_light    =     20       ,
    min_height   = -31000       ,
    max_height   =  11000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_dry_grass"   ,
    } ,

    add_egg   = true                    ,
    egg_image = "default_stone.png"     ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    passive = false,
    attack_type = "dogfight",
    reach = 3,
    damage = 5,
    hp_min = 50,
    hp_max = 150,
    armor = 100,
    visual = "mesh",
    mesh = msname .. ".b3d",
    textures = {
        { msname .. ".png" } ,
    },
    collisionbox = {-1.1, 0, -1.1, 1.1, 2.1, 1.1},
    blood_texture = "mobs_blood.png",
    makes_footstep_sound = true,
    walk_velocity = 1,
    run_velocity = 2,
    stepheight    = 1.2         ,
    jump_height   =   0         ,
    jump          = false       ,
    water_damage = 2,
    floats = 0,
    runaway = true,
    lava_damage = 2,
    light_damage = 0,
    fall_damage = 1,
    fall_speed = -9,
    fear_height = 2,
    replace_rate = 10,
    replace_what = {"default:grass_3", "default:grass_4", "default:grass_5", "ethereal:bamboo"},
    replace_with = "air",

    follow = {
        "compactblocks:default_leaves" ,
    } ,

    view_range = 14,

    drops = {
        { name="mobs:meat_raw", chance=2, min=3, max=4 } ,
    } ,

    specific_attack = codermobs.make_mob_list ({
        "farhorse", "zebra",
    }) ,

    animation = {
        speed_normal = 14,
        speed_run = 16,
        walk_start = 25,
        walk_end = 45,
        stand_start = 1,
        stand_end = 20,
        run_start = 25,
        run_end = 45,
        punch_start = 25,
        punch_end = 45,

    },

    on_rightclick = function(self, clicker)
        if mobs:feed_tame(self, clicker, 8, true, true) then
            return
        end

        mobs:capture_mob(self, clicker, 0, 5, 50, false, nil)
    end,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
