-- Fox. Descended from "dmobs" version.

-- ===================================================================

local lcname     = "fox"
local ucname     = "Fox"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance = 150000       ,

    day_mode     = true         ,
    min_light    =      0       ,
    max_light    =     30       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt"                      ,
        "default:dirt_with_dry_grass"       ,
        "default:dirt_with_grass"           ,
        "default:snow"                      ,
        "default:snowblock"                 ,
        "earthgen:dirt_with_dry_grass"      ,
        "ethereal:green_dirt"               ,
        "ethereal:green_dirt_top"           ,
        "lottmapgen:gondor_grass"           ,
        "lottmapgen:ironhill_grass"         ,
        "lottmapgen:ithilien_grass"         ,
        "lottmapgen:lorien_grass"           ,
        "lottmapgen:mirkwood_grass"         ,
        "lottmapgen:rohan_grass"            ,
        "mg:dirt_with_dry_grass"            ,
        "noisegrid:grass"                   ,
    } ,

    add_egg   = true                        ,
    egg_image = "codermobs_fur_grey.png"    ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    makes_footstep_sound = true  ,

    -- Most behavior/sight/battle
    armor            = 130         ,
    attack_animals   = false       ,
    attack_type      = "dogfight"  ,
	attacks_monsters = true        ,
    damage           =   2         ,
    hp_max           =   5         ,
    passive          = false       ,
	pathfinding      = true        ,
	reach            =   1         ,
    runaway          = true        ,
    view_range       =  14         ,

    -- Velocities
    run_velocity   =   2.5       ,
    walk_velocity  =   1         ,

    -- Step/jump/fall parameters
	fall_damage   =    1         ,
	fear_height   =    4         ,
    jump          = true         ,
    stepheight    =    1.2       ,
    jump_height   =    0         ,

    -- Environment damage
    lava_damage   =    5         ,
    light_damage  =    0         ,
    water_damage  =    0         ,

    -- Misc. parameters
    floats        =    0         ,

    blood_texture    = "mobs_blood.png"                          ,
    collisionbox     = { -0.40, -0.60, -0.40, 0.30, 0.30, 0.30 } ,
    drawtype         = "front"                                   ,
    mesh             = msname .. ".b3d"                          ,
    textures         = {{ msname .. ".png" }}                    ,
    visual           = "mesh"                                    ,
	visual_size      = { x=1.5, y=1.5 }                          ,

	animation = {
		speed_normal = 6,
		speed_run = 15,
		walk_start = 25,
		walk_end = 35,
		stand_start = 51,
		stand_end = 60,
		run_start = 1,
		run_end = 16,
		punch_start = 36,
		punch_end = 51,
	} ,

    drops            = {
        { name="mobs:meat_raw", chance=1, min=2, max=3 } ,
    } ,

	follow           = {
	    "mobs:meat_raw"
    } ,

    sounds           = {
        war_cry = msname .. "_attack" ,
    } ,

    specific_attack  = codermobs.make_mob_list ({
        "hen"          , "rooster"          , "baby_chick"      ,
        "bunny"        ,
    }) ,

	on_rightclick = function(self, clicker)
		if mobs:feed_tame(self, clicker, 8, true, true) then
			return
		end
		mobs:capture_mob(self, clicker, 0, 5, 50, false, nil)
	end,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
