-- Goat. Descended from DonBatman version.

-- ===================================================================

local lcname     = "goat"
local ucname     = "Goat"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance =  50000       ,

    day_mode     = true         ,
    min_light    =      0       ,
    max_light    =     20       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    scale        = 1.5          ,
    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_dry_grass"   ,
        "default:dirt_with_grass"       ,
        "earthgen:dirt_with_dry_grass"  ,
        "ethereal:green_dirt"           ,
        "ethereal:green_dirt_top"       ,
        "fargen:dirt_with_leafy_grass"  ,
        "mg:dirt_with_dry_grass"        ,
        "noisegrid:grass"               ,
    } ,

    add_egg   = true                    ,
    egg_image = "default_grass.png"     ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    makes_footstep_sound = true  ,

    -- Most behavior/sight/battle
    armor          = 200         ,
    attack_type    = "dogfight"  ,
    damage         =   2         ,
    hp_max         =  15         ,
    hp_min         =   5         ,
    passive        = false       ,
    runaway        = true        ,
    view_range     =   7         ,

    -- Velocities
    run_velocity   =   2         ,
    walk_velocity  =   1         ,

    -- Step/jump/fall parameters
    jump           = false       ,
    jump_height    =   0         ,
    stepheight     =   1.2       ,

    -- Environment damage
    lava_damage    =   5         ,
    light_damage   =   0         ,
    water_damage   =   1         ,

    -- Misc. parameters
    floats         =   0         ,

    blood_texture    = "codermobs_blood.png"                     ,
    collisionbox     = { -0.30, -0.01, -0.30, 0.30, 0.75, 0.30 } ,
    drawtype         = "front"                                   ,
    mesh             = msname .. ".b3d"                          ,
    visual           = "mesh"                                    ,
    visual_size      = { x=2, y=2 }                              ,

    textures         = {
        { msname .. "_white.png" } ,
        { msname .. "_brown.png" } ,
        { msname .. "_grey.png"  } ,
    } ,

    animation        = {
        stand_start  =   1 ,
        stand_end    =  60 ,
        walk_start   = 122 ,
        walk_end     = 182 ,
        run_start    = 122 ,
        run_end      = 182 ,
        punch_start  = 183 ,
        punch_end    = 267 ,
        speed_normal =  15 ,
        speed_run    =  15 ,
    } ,

    drops            = {
        { name="mobs:meat_raw", chance = 1, min=1, max=4 } ,
    } ,

    specific_attack  = codermobs.make_mob_list ({
        "badger"     ,
    }) ,

    follow           = "farming:wheat"     ,
    replace_rate     = 50                  ,
    replace_what     = { "group:flora" }   ,
    replace_with     = "air"               ,
    sounds           = { random = msname } ,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
