-- Hedgehog. Descended from "dmobs" version.

-- ===================================================================

local lcname     = "hedgehog"
local ucname     = "Hedgehog"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance =  50000       ,

    day_mode     = true         ,
    min_light    =     10       ,
    max_light    =     20       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    scale        = 1.5          ,
    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_dry_grass"       ,
        "default:dirt_with_grass"           ,
        "default:pine_needles"              ,
        "fargen:dirt_with_leafy_grass"      ,
        "noisegrid:grass"                   ,
    } ,

    add_egg   = true                        ,
    egg_image = "codermobs_fur_brown.png"   ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    makes_footstep_sound  = true ,

    -- Most behavior/sight/battle
    armor          = 130         ,
    hp_min         =  12         ,
    hp_max         =  22         ,
    passive        = true        ,
    runaway        = true        ,
    view_range     =  14         ,

    -- Velocities
    run_velocity   =   1         ,
    walk_velocity  =   0.5       ,

    -- Step/jump/fall parameters
    fall_damage    =   1         ,
    fall_speed     =  -6         ,
    fear_height    =   4         ,
    jump           = false       ,
    jump_height    =   0         ,
    stepheight     =   1.2       ,

    -- Environment damage
    lava_damage    =   2         ,
    light_damage   =   0         ,
    water_damage   =   2         ,

    -- Misc. parameters
    floats         =   0         ,

    blood_texture    = "mobs_blood.png"                          ,
    collisionbox     = { -0.10, -0.10, -0.20, 0.20, 0.20, 0.20 } ,
    mesh             = msname .. ".b3d"                          ,
    textures         = {{ msname .. ".png" }}                    ,
    visual           = "mesh"                                    ,
    visual_size      = { x=2, y=2 }                              ,

    animation        = {
        walk_start   =  1 ,
        walk_end     = 10 ,
        stand_start  =  1 ,
        stand_end    = 10 ,
        run_start    =  1 ,
        run_end      = 10 ,
        speed_normal =  5 ,
        speed_run    = 10 ,
    } ,

    follow           = { "farming:bread" } ,

    on_rightclick    = function (self, clicker)
        if mobs:feed_tame (self, clicker, 8, true, true) then
            return
        end
        mobs:capture_mob (self, clicker, 0, 5, 50, false, nil)
    end ,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
