-- Garter Snake. Descended from NSSM Ice Snake.

-- ===================================================================

local lcname     = "snake_garter"
local ucname     = "GarterSnake"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance = 220000       ,

    day_mode     = true         ,
    min_light    =     10       ,
    max_light    =     20       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_dry_grass"   ,
        "default:dirt_with_grass"       ,
        "earthgen:dirt_with_dry_grass"  ,
        "ethereal:green_dirt"           ,
        "ethereal:green_dirt_top"       ,
        "ethereal:grove_dirt"           ,
        "mg:dirt_with_dry_grass"        ,
        "noisegrid:grass"               ,
    } ,

    add_egg   = false                   ,
    egg_image = msname .. "_egg.png"    ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type         = mobs_param.spawn_type    ,

    hp_max = 27,
    hp_min = 17,
    collisionbox = {-0.7, 0, -0.7, 0.7, 0.50, 0.7},
    visual = "mesh",
    mesh = "codermobs_snake.x",
    textures = {{ msname .. ".png" }} ,
    visual_size = {x=7, y=7},
    makes_footstep_sound = false,
    view_range = 10,
    rotate = 270,
    fear_height = 3,
    walk_velocity = 1.2,
    run_velocity = 3,
    pathfinding = true ,

    sounds = {
        random = msname ,
    },

    damage = 4,
    reach = 2,
    stepheight    = 1.2         ,
    jump_height   =   0         ,
    jump          = false       ,
    armor = 70,
    drawtype = "front",
    water_damage = 1,
    floats = 0,
    runaway = true,
    lava_damage = 20,
    light_damage = 0,
    group_attack=true,
    attack_animals=true,
    knock_back=2,
    blood_texture="codermobs_nssm_blood.png" ,
    on_rightclick = nil,
    attack_type = "dogfight",

    animation = {
        walk_start   =   1 ,
        walk_end     =  60 ,
        run_start    =  80 ,
        run_end      = 120 ,
        punch_start  = 130 ,
        punch_end    = 160 ,
        stand_start  = 170 ,
        stand_end    = 220 ,
        speed_normal =  15 ,
        speed_run    =  25 ,
    } ,

    specific_attack = codermobs.make_mob_list ({
        "bunny" , "snake_ice" ,
    }) ,

--  do_custom = function(self)
--      putting_ability(self, "default:ice", self.run_velocity)
--  end,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
