-- Panda. Descended from "dmobs" version.

-- ===================================================================

local lcname     = "panda"
local ucname     = "Panda"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance =  80000       ,

    day_mode     = true         ,
    min_light    =      5       ,
    max_light    =     30       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_grass"       ,
        "ethereal:bamboo_dirt"          ,
        "fargen:bamboo"                 ,
        "fargen:bamboo_grass"           ,
        "fargen:bamboo_small"           ,
        "noisegrid:grass"               ,
    } ,

    add_egg   = true                    ,
    egg_image = "default_papyrus.png"   ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    makes_footstep_sound = true  ,

    -- Most behavior/sight/battle
    armor          = 130         ,
    attack_type    = "dogfight"  ,
    damage         =   2         ,
    hp_max         =  22         ,
    hp_min         =  12         ,
    passive        = false       ,
    reach          =   1         ,
    runaway        = true        ,
    view_range     =  14         ,

    -- Velocities
    run_velocity   =   1         ,
    walk_velocity  =   0.5       ,

    -- Step/jump/fall parameters
    fall_speed     = -10         ,
    fall_damage    =   1         ,
    fear_height    =   4         ,
    jump           = false       ,
    jump_height    =   0         ,
    stepheight     =   1.2       ,

    -- Environment damage
    lava_damage    =   2         ,
    light_damage   =   0         ,
    water_damage   =   1         ,

    -- Misc. parameters
    floats         =   0         ,

    blood_texture    = "mobs_blood.png"                          ,
    collisionbox     = { -0.40, -0.50, -0.40, 0.40, 0.50, 0.40 } ,
    mesh             = msname .. ".b3d"                          ,
    textures         = {{ msname .. ".png" }}                    ,
    visual           = "mesh"                                    ,
    visual_size      = { x=1, y=1 }                              ,

    animation        = {
        stand_start  = 10 ,
        stand_end    = 10 ,
        walk_start   = 25 ,
        walk_end     = 45 ,
        run_start    = 25 ,
        run_end      = 45 ,
        punch_start  = 46 ,
        punch_end    = 57 ,
        speed_normal =  6 ,
        speed_run    = 10 ,
    } ,

    drops            = {
        { name="mobs:meat_raw", chance=1, min=1, max=1 } ,
    } ,

    follow           = { "default:papyrus" } ,

    replace_rate     = 10   ,
    replace_what     = {
        "default:grass_3" , "default:grass_4" ,
        "default:grass_5" , "ethereal:bamboo" ,
    } ,
    replace_with     = "air" ,

    on_rightclick    = function (self, clicker)
        if mobs:feed_tame (self, clicker, 8, true, true) then
            return
        end
        mobs:capture_mob (self, clicker, 0, 5, 50, false, nil)
    end ,
}

-- ===================================================================

codermobs.setup_mob()
mobs:alias_mob ("mobs:panda"        , obj_name)
mobs:alias_mob ("mobs_animal:panda" , obj_name)
codermobs.log_done()

-- ===================================================================
-- End of file.
