-- Penguin. Descended from D00Med version.

-- ===================================================================

local lcname     = "penguin"
local ucname     = "Penguin"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance =  40000       ,

    day_mode     = true         ,
    min_light    =     10       ,
    max_light    =     20       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_snow"        ,
        "default:snow"                  ,
        "earthgen:ice"                  ,
        "ethereal:green_dirt"           ,
        "ethereal:green_dirt_top"       ,
        "ethereal:grove_dirt"           ,
        "mg:dirt_with_dry_grass"        ,
    } ,

    add_egg   = true                    ,
    egg_image = "default_snow.png"      ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    makes_footstep_sound = true  ,

    armor         = 200          ,
    fear_height   =   2          ,
    floats        =   0          ,
    hp_max        =  10          ,
    hp_min        =   5          ,
    passive       = true         ,
    reach         =   1          ,
    runaway       = true         ,
    run_velocity  =   2          ,
    stepheight    = 1.2         ,
    jump_height   =   0         ,
    jump          = false       ,
    view_range    =   5          ,
    walk_velocity =   1          ,

    lava_damage   =   4          ,
    light_damage  =   0          ,
    water_damage  =   0          ,

    collisionbox  = { -0.2, -0.0, -0.2, 0.2, 0.5, 0.2 } ,
    mesh          = msname .. ".b3d"                    ,
    visual        = "mesh"                              ,
    visual_size   = { x = 0.25, y = 0.25 }              ,
    textures      = {{ msname .. ".png" }}              ,

    -- 50-70 is slide/water idle
    -- 75-95 is swim animation
    --
    animation     = {
        stand_start  =  1 ,
        stand_end    = 20 ,
        walk_start   = 25 ,
        walk_end     = 45 ,
        fly_start    = 75 ,
        fly_end      = 95 ,
        speed_normal = 15 ,
    } ,

    drops = {
        { name="mobs:meat_raw", chance=1, min=1, max=1 } ,
    } ,

    fly_in = { "default:water_source", "default:water_flowing" } ,

    follow = {
        "ethereal:fish_raw"  , "mobs_fish:clownfish" ,
        "mobs_fish:tropical" ,
    } ,

    sounds = {},

    on_rightclick = function(self, clicker)
        -- feed or tame
        if mobs:feed_tame(self, clicker, 4, false, true) then return end
        if mobs:protect(self, clicker) then return end
        if mobs:capture_mob(self, clicker, 5, 50, 80, false, nil) then
            return
        end
    end ,
}

-- ===================================================================

codermobs.setup_mob()
mobs:alias_mob ("mobs:penguin"        , obj_name)
mobs:alias_mob ("mobs_animal:penguin" , obj_name)
codermobs.log_done()

-- ===================================================================
-- End of file.
